﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace SimpleFlowDesigner
{
    public partial class NDSResize : Form
    {
        Control TheParent;

        public NDSResize(Control Parent)
        {

            TheParent = Parent;
            //this.Parent = Parent;

            InitializeComponent();

            Visible = false;

            TopMost = true;

            FormClosing += new FormClosingEventHandler(NDSResize_FormClosing);

            setGbXSize();
        }

        void NDSResize_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (e.CloseReason == CloseReason.UserClosing)
            {
                e.Cancel = true;

                Visible = false;

            }
        }

        private void btnUpdate_Click(object sender, EventArgs e)
        {
            try
            {
                TheParent.Size = new Size(int.Parse(txtX.Text), int.Parse(txtY.Text));

                foreach(Control Node in TheParent.Controls)
                    ((ProcessObject)Node).TestIfOutOfDocBounds();

                setGbXSize();
                
            } catch (Exception Ex)
            {

                MessageBox.Show(Ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Hand);

            } 
        }

        void setGbXSize()
        {

            gbxResize.Text = "Current size is: " + TheParent.Size.Width + ", " + TheParent.Size.Height;

        }

        //protected override void OnVisibleChanged(EventArgs e)
        //{
        //    base.OnVisibleChanged(e);


        //}

        //protected override void OnClosing(CancelEventArgs e)
        //{
        //    if (e.c
        //    e.Cancel = true;

        //    Visible = false;
        //}
    }
}
