﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing;
using System.Xml.Linq;

namespace SimpleFlowDesigner
{
    class NodeDocument : Panel //: NodeContainer
    {
        //public NodeDocument() {

        //    //Location = new Point(0, 20);
        //    //
            
        //    //ToolStrip TS = new ToolStrip();
        //    //ToolStripLabel toolStripLabel1 = new ToolStripLabel();
        //    //ToolStripSeparator toolStripSeparator6 = new ToolStripSeparator();
        //    //ToolStripButton toolStripButton1 = new ToolStripButton();
        //    //ToolStripButton toolStripButton2 = new ToolStripButton();


        //    SuspendLayout();


        //    BackColor = Color.Chocolate;

        //    //SizeChanged += new EventHandler(SimpleFlowDesignerMain_SizeChanged);

        //    ControlAdded += new ControlEventHandler(Document_ControlAdded);

        //    ResumeLayout();
        //    AutoScroll = true;
        //    //AutoScroll = true;
        //    //Padding = new Padding(0, 40, 0, 0);

        //    //NewDocument();

        //    //Controls.Add(new ProcessNode());

        //    //Controls.Add(new DecisionNode());

        //    //Controls.Add(new InputOutPutNode());

        //    //Controls.Add(new PreDefinedProcessNode());

        //    //Controls.Add(new Connector());

        //    //Controls.Add(new Connector());
        
        //}

        //int CentralLoc(int ContnrSize, int ContndSize)
        //{

        //    return ContnrSize / 2 - ContndSize / 2;
        //}

        //void Document_ControlAdded(object sender, ControlEventArgs e)
        //{
        //    //e.Control.Location = new Point(CentralLoc(Width, e.Control.Width), CentralLoc(Height, e.Control.Height));

        //    e.Control.Location = new Point(CentralLoc(Width, e.Control.Width), CentralLoc(Height, e.Control.Height));

        //}

        ////void SimpleFlowDesignerMain_SizeChanged(object sender, EventArgs e)
        ////{
        ////    SetSize();
        ////}

        ////public void SetSize()
        ////{

        ////    Size = new Size(Parent.Width, Parent.Height - Location.Y);

        ////}

        //public void DocArrangeTNodes()
        //{

        //    SuspendLayout();

        //    //Controls[0].Location = new Point(CentralLoc(Width, Controls[0].Width), CentralLoc(Height, Controls[0].Height * 2));

        //    //Controls[1].Location = new Point(CentralLoc(Width, Controls[1].Width), Controls[0].Location.Y + Controls[0].Height);



        //    ResumeLayout();
        //}

        //public void NewDocument()
        //{


        //    if (Controls.Count > 2)
        //    {



        //    }
        //    else
        //    {

        //        ControlAdded -= new ControlEventHandler(Document_ControlAdded);

        //        Controls.Add(new TerminalNode());

        //        Controls.Add(new TerminalNode());

        //        Controls[0].Location = new Point(CentralLoc(Width, Controls[0].Width), CentralLoc(Height, Controls[0].Height * 2));

        //        Controls[1].Location = new Point(CentralLoc(Width, Controls[1].Width), Controls[0].Location.Y + Controls[0].Height);

        //        //DocArrangeTNodes();

        //        ControlAdded += new ControlEventHandler(Document_ControlAdded);

        //    }


        //}

        //public void AddProcessNode() { Controls.Add(new ProcessNode()); }

        //public void AddDecisionNode() { Controls.Add(new DecisionNode()); }

        //public void AddInputOutPutNode() { Controls.Add(new InputOutPutNode()); }

        //public void AddPreDefinedProcessNode() { Controls.Add(new PreDefinedProcessNode()); }

        //public void AddConnector() { Controls.Add(new Connector()); }

        NodeDocumentSurface NDS = new NodeDocumentSurface();

        public NodeDocument() {

            SuspendLayout();

            Controls.Add(NDS);

            MinimumSize = new Size(400, 400);

            //Size = new Size(600, 600);

            //ControlAdded += new ControlEventHandler(Document_ControlAdded);

            ResumeLayout();
            AutoScroll = true;

            Name = "NodeDocument";
        
            //Size = Parent.Parent.Parent
        }

        public void ShowResizeDialogue()
        {

            NDS.ShowResizeDialougue();

        }

        //int CentralLoc(int ContnrSize, int ContndSize)
        //{

        //    //NDS.Centr;
        //}

        //void Document_ControlAdded(object sender, ControlEventArgs e)
        //{
        //    e.Control.Location = new Point(CentralLoc(Width, e.Control.Width), CentralLoc(Height, e.Control.Height));

        //}


        //public void DocArrangeTNodes()
        //{

        //    SuspendLayout();

        //    ResumeLayout();
        //}

        public void NewDocument()
        {

            NDS.NewDocument();

        }

        public void AddProcessNode()
        {
            SuspendLayout();

            NDS.Controls.Add(new ProcessNode());

            ResumeLayout();
        }

        public void AddDecisionNode()
        {
            SuspendLayout();

            NDS.Controls.Add(new DecisionNode());

            ResumeLayout();
        }

        public void AddInputOutPutNode()
        {
            SuspendLayout();

            NDS.Controls.Add(new InputOutPutNode());

            ResumeLayout();
        }

        public void AddPreDefinedProcessNode()
        {
            SuspendLayout();

            NDS.Controls.Add(new PreDefinedProcessNode());

            ResumeLayout();
        }

        public void AddConnector()
        {
            SuspendLayout();

            NDS.Controls.Add(new Connector());

            ResumeLayout();
        }

        public void LoadDoc(XElement doc)
        {

            SuspendLayout();

            IEnumerable<XElement> docEls = doc.Elements();

            Name = doc.Name.ToString();

            int TNcount = 0;

            foreach (XElement Node in docEls)
            {

                switch (Node.Name.ToString())
                {

                    case "Settings":

                        NDS.Width = int.Parse(Node.Attribute("Width").Value);

                        NDS.Height = int.Parse(Node.Attribute("Height").Value);

                        break;

                    case "TerminalNode":

                        if (TNcount < 3)
                        {

                            TerminalNode TN = (TerminalNode)NDS.Controls[TNcount];

                            TN.LoadNode(Node.Attribute("Width").Value, Node.Attribute("Height").Value, Node.Attribute("Location.X").Value, Node.Attribute("Location.Y").Value); 

                            TNcount++;

                            TN.TestIfOutOfDocBounds();

                            if (TNcount == 2)
                                TN.CompletedTNodeCreation();
                        }

                        break;

                    case "ProcessNode":

                        ProcessNode PN = new ProcessNode();

                        NDS.Controls.Add(PN);
                        
                        PN.LoadProcessNode(Node.Attribute("Width").Value, Node.Attribute("Height").Value, Node.Attribute("Location.X").Value, Node.Attribute("Location.Y").Value, Node.Attribute("Text").Value);

                        PN.TestIfOutOfDocBounds();

                        break;

                    case "DecisionNode":

                        DecisionNode DN = new DecisionNode();

                        NDS.Controls.Add(DN);
                            
                        DN.LoadDecisionNode(Node.Attribute("Width").Value, Node.Attribute("Height").Value, Node.Attribute("Location.X").Value, Node.Attribute("Location.Y").Value, Node.Attribute("Text").Value);

                        DN.TestIfOutOfDocBounds();

                        break;

                    case "InputOutPutNode":

                        InputOutPutNode ION = new InputOutPutNode();

                        NDS.Controls.Add(ION);
                        
                        ION.LoadInputOutPutNode(Node.Attribute("Width").Value, Node.Attribute("Height").Value, Node.Attribute("Location.X").Value, Node.Attribute("Location.Y").Value, Node.Attribute("Text").Value);

                        ION.TestIfOutOfDocBounds();

                        break;

                    case "PreDefinedProcessNode":

                        PreDefinedProcessNode PDPN = new PreDefinedProcessNode();

                        NDS.Controls.Add(PDPN);

                        if (Node.Elements().Count() < 1) {
                            
                            PDPN.LoadNode(Node.Attribute("Width").Value, Node.Attribute("Height").Value, Node.Attribute("Location.X").Value, Node.Attribute("Location.Y").Value);

                        } else {
                        
                            //NDS.Controls.Add(new PreDefinedProcessNode(Node.Attribute("Width").Value, Node.Attribute("Height").Value, Node.Attribute("Location.X").Value, Node.Attribute("Location.Y").Value, (XElement)Node.FirstNode));

                            PDPN.LoadPreDefinedProcessNode(Node.Attribute("Width").Value, Node.Attribute("Height").Value, Node.Attribute("Location.X").Value, Node.Attribute("Location.Y").Value, (XElement)Node.FirstNode);
                        }

                        PDPN.TestIfOutOfDocBounds();

                        break;

                    case "Connector":

                        Connector NewCon = new Connector();

                        NDS.Controls.Add(NewCon);

                        NewCon.LoadConnector(Node.Attribute("Text").Value, Node.Attribute("Horisontial").Value, Node.Attribute("ConWidth").Value, Node.Attribute("ArrowState").Value, Node.Attribute("LabelVisibleState").Value, Node.Attribute("Location.X").Value, Node.Attribute("Location.Y").Value);

                        //NDS.Controls.Add(new Connector(Node.Attribute("Text").Value, Node.Attribute("Horisontial").Value, Node.Attribute("ConWidth").Value, Node.Attribute("ArrowState").Value, Node.Attribute("LabelVisibleState").Value));

                        NewCon.TestIfOutOfDocBounds();

                        break;
                }

                //foreach(ProcessObject in 
            }

            ResumeLayout();
        }

    }
}
