using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;

namespace SimpleFlowDesigner
{
    class NodeResize : NodeControl
    {

        Point LastPos; // = new Point();
        Point PosInBtn; //= new Point();
        Size TheNewSize; // = new Point();

        public NodeResize() {

            Text = "R";
        
        }

        protected override void OnMouseUp(MouseEventArgs mevent)
        {
            base.OnMouseUp(mevent);

            MouseMove -= new MouseEventHandler(NodeMove_MouseMove);

            ((IHideShowChildren)Parent).SetSizeInParentBounds();
        }

        //public void SetSizeInParentBounds()
        //{

        //    int XLocation = Parent.Location.X + Parent.Size.Width;
        //    int YLocation = Parent.Location.Y + Parent.Size.Height;

        //    bool H = IsOverBounds(Parent.Parent.Size.Width, XLocation);
        //    bool V = IsOverBounds(Parent.Parent.Size.Height, YLocation);

        //    if (H)
        //    {

        //        Parent.Size = new Size(ShrinkNode(Parent.Parent.Size.Width, XLocation, Parent.Size.Width), Parent.Size.Height);

        //        Parent.Refresh();
        //    }

        //    if (V)
        //    {

        //        Parent.Size = new Size(Parent.Size.Width, ShrinkNode(Parent.Parent.Size.Height, YLocation, Parent.Size.Height));

        //        Parent.Refresh();
        //    }

        //    //if (!H || !V)
        //        //Parent.Refresh();

        //}

        protected override void OnMouseDown(MouseEventArgs mevent)
        {
            base.OnMouseDown(mevent);

            MouseMove += new MouseEventHandler(NodeMove_MouseMove);

            LastPos.X = mevent.X;
            LastPos.Y = mevent.Y;

        }

        protected void NodeMove_MouseMove(object sender, MouseEventArgs e)
        {

            GrowShrink(e);
        }

        void GrowShrink(MouseEventArgs e)
        {
            MoveableNode TheParent = (MoveableNode)Parent;

            PosInBtn = e.Location;

            TheNewSize = (TheParent.Size + new Size(PosInBtn.X - LastPos.X, PosInBtn.Y - LastPos.Y));

                TheParent.Size = TheNewSize;

                SetLastPosition(LastPos, PosInBtn);


                Parent.Refresh();
                

        }

        //int ShrinkNode(int TotalLoc, int LocationOver, int ParentsSize)
        //{
        //    int Offset = TotalLoc - LocationOver;

        //    return ParentsSize + Offset - 1;

        //}

        //bool IsOverBounds(int ParentParentWidth, int LocationAndSize)
        //{

        //    return ParentParentWidth < LocationAndSize;

        //}


        protected void SetLastPosition(Point LastPos, Point PosInBtn)
        {
            LastPos = PosInBtn;

        }

    }
}
