using System;
using System.Collections.Generic;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace SimpleFlowDesigner
{
    public abstract class ResizeableNode : NodeBase
    {
        NodeResize NR = new NodeResize();

        public ResizeableNode() {

            SizeChanged += new EventHandler(ResizableNode_SizeChanged);

            Controls.Add(NR);

            Width++;
        
        }

        void ResizableNode_SizeChanged(object sender, EventArgs e)
        {

            int HalfIn = InterButtonBuffer / 2;       

            NR.Location = new Point(Width - NR.Width - HalfIn, Height - NR.Height - HalfIn);
        }

    }
}
