using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Drawing.Drawing2D;

namespace SimpleFlowDesigner
{
    public class NodeOutLine
    {

        Pen ThePen;

        public NodeOutLine() {

            ThePen = new Pen(Color.Black, 3);

        }

        public NodeOutLine(Pen ThePen) { 
        
            this.ThePen = ThePen; 
        
        }

        public void DrawOutLine(Graphics g, Point[] p) {

            GraphicsPath GP = new GraphicsPath();

            GP.AddLines(p);

            g.DrawPath(ThePen, GP);
        
        }

        public Pen DrawingPen {

            get {

                return ThePen;

            }

            set {

                ThePen = value;
            
            }
        
        } 

    }
}
