using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace SimpleFlowDesigner
{
    public abstract class NodeBase : MoveableNode
    {

        protected Label lblPocText = new Label();

        public NodeBase() {

            //lblPocText.SizeChanged += new EventHandler(lblPocText_SizeChanged);

            this.Size = new Size(2 * NodeInteriorBuffer + lblPocText.Width, 2 * NodeInteriorBuffer + lblPocText.Height);

            lblPocText.Location = new Point(NodeInteriorBuffer, NodeInteriorBuffer);

            //lblPocText.AutoSize = true;

            lblPocText.TextAlign = ContentAlignment.MiddleCenter;

            //lblPocText.BackColor = Color.Cornsilk;

            lblPocText.BackColor = Color.Transparent;

            SizeChanged += new EventHandler(NodeBase_SizeChanged);

            //lblPocText.Location = new Point(NodeInteriorBuffer, NodeInteriorBuffer);

            Controls.Add(lblPocText);

        }

        void NodeBase_SizeChanged(object sender, EventArgs e)
        {
            int NodeInteriorBufferT2 = NodeInteriorBuffer * 2;

            lblPocText.Width = Width - NodeInteriorBufferT2;
            lblPocText.Height = Height - NodeInteriorBufferT2;

        }

        public void NoBaseSizeChanged() {

            SizeChanged -= new EventHandler(NodeBase_SizeChanged);
        
        }

        //protected void lblPocText_SizeChanged(object sender, EventArgs e)
        //{
        //    Width = lblPocText.Location.X + lblPocText.Width + NodeInteriorBuffer;
        //    Height = lblPocText.Location.Y + lblPocText.Height + NodeInteriorBuffer;
        //}

        //protected void OnSizeChanged(object sender, EventArgs e)
        //{

        //    lblPocText.Width = Width - NodeInteriorBuffer;
        //    lblPocText.Height = Height - NodeInteriorBuffer;

        //    base.OnSizeChanged(e);

        //}



        public override string Text
        {

            get { return lblPocText.Text; }

            set { lblPocText.Text = value; }

        }

        //protected override void OnMouseEnter(EventArgs e)
        //{
        //    if (LastControl != null)
        //    {

        //        LastControl.HideChildren();

        //        LastControl = null;

        //    }

        //    base.OnMouseEnter(e);

        //}

        //public override Font Font
        //{

        //    get { return lblPocText.Font; }

        //    set { lblPocText.Font = value; }

        //}

    }
}
