using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Xml.Linq;

namespace SimpleFlowDesigner
{
    abstract public class ProcessObject : Panel
    {

        protected static int InterButtonBuffer = 4;

        protected static int SideTopBuffer = 5;

        protected static int NodeInteriorBuffer = 60;

        //delegate void OpacUpDown(Control Cont);

        //Timer Opctmr = new Timer();

        //OpacUpDown OpacD;

        //Point MLocation;

        //protected Stack<NodeControl> SNC = new Stack<NodeControl>();

        //bool HasEnteredChildControl;

        //bool AreChildButtonsVisible;

        public ProcessObject() {


            BackColor = Color.Transparent;
            //ControlAdded += new ControlEventHandler(ProcessObject_ControlAdded);

            //MouseEnter += new EventHandler(ProcessObject_MouseEnter);

            //Disposed += new EventHandler(ProcessObject_Disposed);

            //MouseLeave += new EventHandler(ProcessObject_MouseLeave);

            //MouseMove += new MouseEventHandler(ProcessObject_MouseMove);
            //Opctmr.Interval = 15;

            //Opctmr.Tick += new EventHandler(Opctmr_Tick);

        }


        public void TestIfOutOfDocBounds()
        {

            if (Location.X < 0)
            {

                Location = new Point(0, Location.Y);

            }

            if (Location.Y < 0)
            {
                Location = new Point(Location.X, 0);

            }

            if (Location.X + Width > Parent.Width)
            {

                Location = new Point(Parent.Width - Width, Location.Y);

            }

            if (Location.Y + Height > Parent.Height)
            {
                Location = new Point(Location.X, Parent.Height - Height);

            }

        }

        protected List<XAttribute> ProfilePONode()
        {
            List<XAttribute> POList = new List<XAttribute>();
            
            POList.Add(new XAttribute("Width", Width));
            POList.Add(new XAttribute("Height", Height));
            POList.Add(new XAttribute("Location.X", Location.X));
            POList.Add(new XAttribute("Location.Y", Location.Y));

            return POList;

        }

        public void LoadNode(string NewWidth, string NewHeight, string LocationX, string LocationY)
        {

            Width = int.Parse(NewWidth);
            Height = int.Parse(NewHeight);
            Location = new Point(int.Parse(LocationX), int.Parse(LocationY));

        }

        //void ProcessObject_Disposed(object sender, EventArgs e)
        //{
        //    //Parent.Controls.Remove(this); //Seems to have already been performed.

        //    //foreach (Control c in Controls)
        //    //    Controls.Remove(c);           //So has this...

        //    //MouseEnter -= new EventHandler(ProcessObject_MouseEnter);

        //    Disposed -= new EventHandler(ProcessObject_Disposed);

        //}

        //public void ShowChildren()
        //{

        //    SetChildVisibleState(true);

        //}

        //public void HideChildren()
        //{

        //    SetChildVisibleState(false);

        //}

        //void SetChildVisibleState(bool state)
        //{

        //    foreach (Control c in Controls)
        //    {
        //        if (c.GetType() != typeof(Label))
        //            c.Visible = state;

        //        AreChildButtonsVisible = state;
        //    }
        //}

        //protected override void OnMouseEnter(EventArgs e)
        //{
        //    if (LastControl != null)
        //    {

        //        LastControl.HideChildren();

        //        LastControl = null;

        //    }

        //    base.OnMouseEnter(e);

        //}

        //void ProcessObject_MouseMove(object sender, MouseEventArgs e)
        //{
        //    //MLocation = e.Location;
        //}

        //void ProcessObject_ControlAdded(object sender, ControlEventArgs e)
        //{
        //    Control Cont = e.Control;

        //    //Cont.MouseEnter += new EventHandler(Cont_MouseEnter);

        //    //Cont.MouseLeave += new EventHandler(Cont_MouseLeave);
        //}

        //void Cont_MouseLeave(object sender, EventArgs e)
        //{
        //    HasEnteredChildControl = false;
            
        //    //ReverseHasEnteredCC();
        //}

        //void Cont_MouseEnter(object sender, EventArgs e)
        //{

        //    HasEnteredChildControl = true;

        //    //ReverseHasEnteredCC();
        //}



        //void Opctmr_Tick(object sender, EventArgs e)
        //{
        //    SetHidden();
        //}

        //void ProcessObject_MouseLeave(object sender, EventArgs e)
        //{

        //    //StopIfEnabled();

        //    OpacD = OpacDown;

        //    //if ((MLocation.X > Location.X && MLocation.X < Width) || (MLocation.Y > Location.Y && MLocation.Y < Height))
        //    //if ((MLocation.X > Location.X || MLocation.X < Width) || (MLocation.Y > Location.Y || MLocation.Y < Height))
            
        //    if(!HasEnteredChildControl)
        //        SetHidden();

            
        //    //Opctmr.Start();
        //}

        //void ProcessObject_MouseEnter(object sender, EventArgs e)
        //{

        //    //StopIfEnabled();

        //    //OpacD = OpacUp;

        //    //SetHidden();



        //    //Opctmr.Start();
        //}

        //void HideRevealChildren()
        //{ 
        
        //    Control Cont;

        //    for(int i = 0; i < Controls.Count; i++) {

        //    Cont = Controls[i];

        //    if (Cont.GetType() != typeof(Label))

        //        Cont.Visible = !Cont.Visible;

        //        ////do {
        //        //OpacD(Cont);
        //        //} while(Cont.Opacity
        //    }
        //}

        //void OpacUp(Control Cont)
        //{

        //    //Cont.Visible = true;

        //    Cont.Enabled = true;
        
        //}

        //void OpacDown(Control Cont)
        //{

        //    Cont.Enabled = false;
        
        //}

        //void ReverseHasEnteredCC() {

        //    HasEnteredChildControl = !HasEnteredChildControl;
        
        //}

        //void StopIfEnabled() {

        //    if (Opctmr.Enabled)
        //    {

        //        Opctmr.Stop();

        //    }
        
        //}

        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);

            
        }


    }
}
