using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Xml.Linq;

namespace SimpleFlowDesigner
{
    class DecisionNode : EditableTextNode //, ISaveMyself
    {

        public DecisionNode() {

            Initalise();

        }

        public void LoadDecisionNode(string NewWidth, string NewHeight, string LocationX, string LocationY, string NewText)
        {
            //Initalise();

            LoadNode(NewWidth, NewHeight, LocationX, LocationY);

            Text = NewText;

        }

        void Initalise()
        {

        Name = "DecisionNode";

        //BackColor = Color.Orange;

        //BackColor = Color.Transparent;

        MinimumSize = Size;

        //UpdateThePoints = UpdatePoints;

        //Appearance.AddLines(UpdatePoints());

        Text = "DecisionNode";

        }

        protected override void OnPaint(PaintEventArgs e)
        {
            Graphics g = e.Graphics;

            //g.DrawPath(ForePen, Appearance);

            NO.DrawOutLine(g, UpdatePoints());

            base.OnPaint(e);
        }

        //public XElement ProfileMe()
        //{

        //    List<XAttribute> MyAttributes = ProfilePONode();

        //    XElement MeInXmlForm = new XElement("DecisionNode");

        //    foreach (XAttribute Attribute in MeInXmlForm.Attributes())
        //        MeInXmlForm.Add(Attribute);

        //    return MeInXmlForm;

        //}

        //protected override void OnResize(EventArgs eventargs)
        //{
        //    base.OnResize(eventargs);

        //    Appearance.Reset();

        //    Appearance.AddLines(UpdatePoints());

        //}

        Point[] UpdatePoints()
        {

            int HalfHeight = HalfDimention(Height);

            int HalfWidth = HalfDimention(Width);

            Point[] NewPoints = { new Point(HalfWidth, InteriorPadding), new Point(Width - InteriorPadding, HalfHeight), new Point(HalfWidth, Height - InteriorPadding), new Point(InteriorPadding, HalfHeight), new Point(HalfWidth, InteriorPadding) };

            return NewPoints;
        }

        int HalfDimention(int Dimention)
        {

            return Dimention = Dimention / 2;

        }

    }
}
