using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;
using System.Xml.Linq;

namespace SimpleFlowDesigner
{
    class InputOutPutNode : EditableTextNode //, ISaveMyself
    {

        protected int InclineOutcline;

        public InputOutPutNode() {

            Initalise();

        }

        public void LoadInputOutPutNode(string NewWidth, string NewHeight, string LocationX, string LocationY, string NewText)
        {
            //Initalise();

            LoadNode(NewWidth, NewHeight, LocationX, LocationY);

            Text = NewText;

        }

        void Initalise()
        {

            Name = "InputOutPutNode";

            //BackColor = Color.Plum;

            //BackColor = Color.Transparent;

            //UpdateThePoints = UpdatePoints;

            MinimumSize = Size;

            SetDimentions();

            //Appearance.AddLines(UpdatePoints());

            Height++; //Stops a black Boarder from apperaring

            Text = "InputOutPutNode";

        }

        //public XElement ProfileMe()
        //{

        //    List<XAttribute> MyAttributes = ProfilePONode();

        //    XElement MeInXmlForm = new XElement("InputOutPutNode");

        //    foreach (XAttribute Attribute in MeInXmlForm.Attributes())
        //        MeInXmlForm.Add(Attribute);

        //    return MeInXmlForm;

        //}

        protected void SetDimentions()
        {

            InclineOutcline = Width / 10;

        }

        Point[] UpdatePoints()
        {

            Point[] NewPoints = { new Point(InclineOutcline, InteriorPadding), new Point(Width - InteriorPadding, InteriorPadding), new Point(Width - InclineOutcline - InteriorPadding, Height - InteriorPadding), new Point(InteriorPadding, Height - InteriorPadding), new Point(InclineOutcline, InteriorPadding) };

            return NewPoints;
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);

            Graphics g = e.Graphics;

            NO.DrawOutLine(g, UpdatePoints());
        }

    }
}
